c     Automatically determine the path to the system's PDF set
c     collection using the lhapdf-config utility (which must be
c     in the user's execution path
c     ---------------------------------------------------------
      subroutine InitPDFsetByCodes(code1, code2, code3)
      write(*,*) "Not implemented yet: this will move the 'glue' interf
     +ace to LHAPDF proper and use the InitPDFsetByName function to get
     +the path automatically."
      return
      end
c     ---------------------------------------------------------


c     Automatically determine the path to the system's PDF set
c     collection using the lhapdf-config utility (which must be
c     in the user's execution path
c     --------------------------------------------------------
      subroutine InitPDFsetByName(setname)
      implicit none
      character setname*(*)
      integer nset
      nset = 1
      call InitPDFsetByNameM(nset,setname)
      return
      end

      
      subroutine InitPDFsetByNameM(nset,setname)
      implicit none
      include 'parmsetup.inc'
      include 'pathsetup.inc'
      common/LHAPDFC/lhapath
      character*20 lhaparm(20)
      real*8 lhavalue(20)
      common/LHACONTROL/lhaparm,lhavalue
      character setname*(*)
      integer nset
c     integer :: ierror
      integer n, dirpathlength, setnamelength
      character*512 dirpath, homepath, dotlhapath, cachepath, setpath

c     find the directory with the PDfsets
      call getdirpath(dirpath)

c     Now build the path to the PDF set
      setpath = dirpath(:LEN_TRIM(dirpath)) // "/" //
     +setname(:LEN_TRIM(setname))
c     write(*,*) setpath(:lnblnk(setpath))

c     Initialize using the detected PDF set
      call InitPDFsetM(nset, setpath(:LEN_TRIM(setpath)))
      return
      end
c     ---------------------------------------------------------

      subroutine InitPDFset(setpath)
      implicit none
      integer nset
      character setpath*(*)
      nset = 1
      call InitPDFsetM(nset,setpath)
      return
      end      
c
      subroutine InitPDFsetM(nset,setpath)
      implicit none
      include 'parmsetup.inc'
      character setpath*(*)
      character*64 string
      character*16 s1,s2
      integer id,token,Ctoken
c  Verbosity control from lhaglue - check! (AB 2008-03-20)
      character*20 lhaparm(20)
      double precision lhavalue(20)
      common/lhacontrol/lhaparm,lhavalue
      integer lhaonce
      save lhaonce
      data lhaonce/0/
c
      integer lhasilent
      common/lhasilent/lhasilent
      integer nset,imem
c
      lhasilent = 0
      if (lhaparm(19).eq.'SILENT') then
         lhasilent = 1
      elseif (lhaparm(19).eq.'LOWKEY') then
         if (lhaonce .eq. 0) then
            lhaonce = 1
         else
            lhasilent = 1
         endif
      endif
c
      call setnset(nset)
c      
c      print *,setpath
      open(unit=1,file=setpath,status='old')
      read(1,*) s1,s2
      if ((index(s2,'1.0').ne.1)
     +.and.(index(s2,'1.1').ne.1)
     +.and.(index(s2,'2.0').ne.1)
     +.and.(index(s2,'2.1').ne.1)
     +.and.(index(s2,'3.0').ne.1) 
     +.and.(index(s2,'3.1').ne.1)
     +.and.(index(s2,'4.0').ne.1)
     +.and.(index(s2,'5.0').ne.1)
     +.and.(index(s2,'5.3').ne.1)
     +.and.(index(s2,'5.4').ne.1))then
         write(*,*) 
     .        'Version ',s2,' not supported by this version of LHAPDF'
         stop
      else  
       if (lhasilent.eq.0) then
         write(*,*) '*************************************'
         write(*,*) '*       LHAPDF Version 5.4.1        *'
         write(*,*) '*************************************'
         write(*,*)
       endif
      endif
      id=Ctoken()
 1    read(1,*) string
      id=token(string)
c      print *,'id = ',id,string
      if (id.eq.0) then
         write(*,*) 'File description error:'
         write(*,*) 'Command not understood: ',string
         stop
      endif
      if (id.eq.1) call descriptionPDF(nset,id)
c      print *,'1/2'
      if (id.eq.2) call initEvolve(nset)
c      print *,'2/3'
      if (id.eq.3) call initAlphasPDF(nset)
c      print *,'3/4'
      if (id.eq.4) call initInputPDF(nset)
c      print *,'4/5'
      if (id.eq.5) call initListPDF(nset)
c      print *,'5/6'
      if (id.eq.6) call initQCDparams(nset)
c      print *,'6/7'
      if (id.eq.7) call initMinMax(nset)
c      print *,'7/8'
      if (id.ne.8) goto 1
      close(1)
c      print *,'calling InitEvolveCode',nset
      call InitEvolveCode(nset)
*
c initialize the default member 0
      call InitPDFM(nset,0)

      return
      end
*     
      integer function token(s)
      implicit none
      character*16 s
      integer not,i,Ctoken
      parameter(not=8)
      character*16 t(not)
      data t/'Description:','Evolution:','Alphas:',
     .                    'Parametrization:','Parameterlist:',
     .                    'QCDparams:','MinMax:',
     .                    'End:'/
      integer count(not)
      save count
*
      token=0
      do i=1,not
         if (s.eq.t(i)) token=i
      enddo
      if (token.ne.0) then
         count(token)=count(token)+1
         if (count(token).eq.2) then
            write(*,*) 'File description error:'
            write(*,*) 'Second definition of entry: ',s
            stop
         endif
      endif
      return
*
      entry Ctoken()
      do i=1,not
         count(i)=0
      enddo
      Ctoken=0
      return
*     
      end
c
      subroutine LHAprint(iprint)
      implicit none
      integer lhasilent,iprint
      common/lhasilent/lhasilent
      lhasilent=iprint
c      print *,'lhasilent',lhasilent
      return
      end
c==============================================================
c the following was moved from lhaglue.f
c
      BLOCK DATA LHAPDFSET
c... additions for multiset use
      include 'parmsetup.inc'
      include 'pathsetup.inc'
c      character*172 LHANAMES(nmxset)
      integer LHASET, LHAMEMB
      common/LHAPDF/LHANAME, LHASET, LHAMEMB
      integer LHAMEMBERS(nmxset),LHANUMBERS(nmxset)
      common/LHASETS/LHANAMES,LHANUMBERS,LHAMEMBERS,nsets
      data nsets/0/
c...
c      CHARACTER*132 LHAPATH
      COMMON/LHAPDFC/LHAPATH
      SAVE /LHAPDFC/
      DATA LHAPATH/'PDFsets'/ ! Default = PDFsets (below current dir)
      CHARACTER*20 LHAPARM(20)
      DOUBLE PRECISION LHAVALUE(20)
      COMMON/LHACONTROL/LHAPARM,LHAVALUE
      SAVE/LHACONTROL/
      DATA LHAPARM /20*' '/
      DATA LHAVALUE /20*0.0D0/
      DOUBLE PRECISION XMINNUM,XMAXNUM,Q2MINNUM,Q2MAXNUM,TOTNUM,
     >                 XMINNUP,XMAXNUP,Q2MINNUP,Q2MAXNUP,TOTNUP
      COMMON/LHAGLSTA/ XMINNUM,XMAXNUM,Q2MINNUM,Q2MAXNUM,TOTNUM,
     >                 XMINNUP,XMAXNUP,Q2MINNUP,Q2MAXNUP,TOTNUP
      SAVE/LHAGLSTA/
      DATA XMINNUM,XMAXNUM,Q2MINNUM,Q2MAXNUM,TOTNUM/5*0.D0/
      DATA XMINNUP,XMAXNUP,Q2MINNUP,Q2MAXNUP,TOTNUP/5*0.D0/
      END
c****************************************************************************
      subroutine setPDFpath(pathname)
      implicit real*8 (A-H,O-Z)
      include 'parmsetup.inc'
      character*(*) pathname
      include 'pathsetup.inc'
c      character*132 lhapath
      common/LHAPDFC/lhapath
      character*20 lhaparm(20)
      real*8 lhavalue(20)
      common/LHACONTROL/lhaparm,lhavalue
      lhaparm(20) = 'LHAPATH'
c      do j=1,lnblnk(lhapath)
      do j=1,LEN_TRIM(lhapath)
        lhapath(j:j)=''
      enddo
      lhapath = pathname
      return
      end
c***********************************************************************  
      subroutine lhaset(lhaparm2,lhavalue2)
      implicit real*8 (a-h,o-z)
      character*20 lhaparm(20),lhaparm2(20)
      real*8 lhavalue(20),lhavalue2(20)
      common/LHACONTROL/lhaparm,lhavalue
      do j=1,20
       lhaparm(j)=lhaparm2(j)
       lhavalue(j)=lhavalue2(j)
      enddo
      return
      end
c******************************************************************
      subroutine setlhaparm(lparm)
      implicit real*8 (a-h,o-z)
c      character*(*) lparm,parm
      character*(*) lparm
      character*20 lhaparm(20)
      real*8 lhavalue(20)
      common/LHACONTROL/lhaparm,lhavalue
      if(lparm.eq.'EKS98') then
        lhaparm(15)='EKS98'
      else if(lparm.eq.'EPS08') then
        lhaparm(15)='EPS08'
      else if(lparm.eq.'15') then
        lhaparm(15)=''
      else if(lparm.eq.'NOSTAT') then
        lhaparm(16)='NOSTAT'
      else if (lparm.eq.'16') then
        lhaparm(16)=''
      else if (lparm.eq.'LHAPDF') then
        lhaparm(17)='LHAPDF'
      else if (lparm.eq.'17') then
        lhaparm(17)=''
      else if (lparm.eq.'EXTRAPOLATE') then
        lhaparm(18)='EXTRAPOLATE'
      else if (lparm.eq.'18') then
        lhaparm(18)=''
      else if (lparm.eq.'SILENT') then
        lhaparm(19)='SILENT'
      else if (lparm.eq.'LOWKEY') then
        lhaparm(19)='LOWKEY'
      else if (lparm.eq.'19') then
        lhaparm(19)=''
      else
        print *,'WARNING from SetLHAPARM - value',lparm,' 
     & not recognized!'  
      endif	
      return

      entry getlhaparm(nparm,lparm)
      lparm = lhaparm(nparm)
      return
      
      end
c***************************************************************
      subroutine getdirpath(dirpath)
c
c This routine is to determine the directory path for the PDFsets
c directory. It has a two fold purpose: 
c 1) to return the value as an argument in dirpath for the native 
c    LHAPDF use (ie via initPDFSetByName
c 2) to fill the value of lhapath in the LHAPDFC common for use in 
c    lhaglue.
c
      implicit real*8 (a-h,o-z)
      include 'parmsetup.inc'
      include 'pathsetup.inc'
      common/LHAPDFC/lhapath
      character*20 lhaparm(20)
      character*(*) dirpath

c first look in the LHAPDFC array (20-set by setPDFpath)
c next check environmental variable LHAPATH
c finally use binreloc via getdatapath(...) 
c will use default path if this all fails

      if (lhaparm(20).ne.'LHAPATH') then
        call getenv('LHAPATH',lhapath)
        if (lhapath.eq.'') then
          call getdatapath(dirpath)
          lhapath=dirpath
        endif
      endif
      dirpath = lhapath 
      return
      end
c***************************************************************
      
