#include "LHAPDF/FortranWrappers.h"
#include "binreloc.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>

#define SIZE 499


#define fgetdirpath FC_FUNC(getdirpath, GETDIRPATH)
void fgetdirpath(char*, int);


#define fgetprefixpath FC_FUNC(getprefixpath, GETPREFIXPATH)
void fgetprefixpath(char* prefixpath, int length) {
  BrInitError error;
  char* prefixdir;
  size_t i;
  br_init_lib(&error);
  prefixdir = br_find_prefix(DEFAULTPREFIXPATH); /* Needs free? */
  assert(strlen(prefixdir) <= length);
  strncpy(prefixpath, prefixdir, length);
  /* Replace null-terminated string convention with Fortran 
     "trailing spaces" convention: */
  for (i = strlen(prefixpath); i < length; ++i) {
    prefixpath[i] = ' ';
  }
  /* printf("@@%s@@\n", datapath); */
}


#define fgetindexpath FC_FUNC(getindexpath, GETINDEXPATH)
void fgetindexpath(char* indexpath, int length) {
  char* datadir;
  char tmp[SIZE], try1[SIZE], try2[SIZE];
  size_t i;
  fgetdirpath(tmp, SIZE+1);
  tmp[SIZE+1] = '\0';
  for (i = SIZE; i >= 0; --i) {
    if (tmp[i] != ' ') break;
    tmp[i] = '\0';
  }
  strncpy(try1, tmp, SIZE);
  strncpy(try2, tmp, SIZE);
  strncat(try1, "/PDFsets.index", SIZE);
  strncat(try2, ".index", SIZE);
  if (access(try1, R_OK) == 0) {
    assert(strlen(try1) <= length);
    strncpy(indexpath, try1, length);
  } else {
    /* printf("@@%s@@\n", try2); */
    assert(strlen(try2) <= length);
    strncpy(indexpath, try2, length);
  }
  /* Replace null-terminated string convention with Fortran 
     "trailing spaces" convention: */
  for (i = strlen(indexpath); i < length; ++i) {
    indexpath[i] = ' ';
  }
}


#define fgetdatapath FC_FUNC(getdatapath, GETDATAPATH)
void fgetdatapath(char* datapath, int length) {
  BrInitError error;
  char* sharedir;
  char tmp[SIZE];
  size_t i;
  br_init_lib(&error);
  sharedir = br_find_data_dir(DEFAULTLHAPATH); /* Needs free? */
  strncpy(tmp, sharedir, strlen(tmp));
  strncat(tmp, "/lhapdf/PDFsets", strlen(tmp)-strlen(sharedir));
  if (access(tmp, R_OK) == 0) {
    assert(strlen(tmp) <= length);
    strncpy(datapath, tmp, length);
  } else {
    assert(strlen(DEFAULTLHAPATH) <= length);
    strncpy(datapath, DEFAULTLHAPATH, length);
    strncat(datapath, "/lhapdf/PDFsets", length-strlen(DEFAULTLHAPATH));
  }
  /* Replace null-terminated string convention with Fortran 
     "trailing spaces" convention: */
  for (i = strlen(datapath); i < length; ++i) {
    datapath[i] = ' ';
  }
  /* printf("@@%s@@\n", datapath); */
}
